import matplotlib.pyplot as plt
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn import tree
from sklearn import metrics
import pandas as pd

import time
import datetime

def stringdate_to_datetime(stringdatetime: str):
    if "." in stringdatetime:
        stringdatetime=stringdatetime.split(".")[0]
    else:
        stringdatetime=stringdatetime.split("Z")[0]
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))


TV_power= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/TV_power.csv', sep= ',')
TV_power["datetime"]=TV_power["time"].apply(stringdate_to_datetime)

Box_TV= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Box_TV.csv', sep= ',')
Box_TV["datetime"]=Box_TV["time"].apply(stringdate_to_datetime)

Bruit= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Bruit.csv', sep= ',')
Bruit["datetime"]=Bruit["time"].apply(stringdate_to_datetime)

Lumière= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Lumière.csv', sep= ',')
Lumière["datetime"]=Lumière["time"].apply(stringdate_to_datetime)

Luminosité= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Luminosité.csv', sep= ',')
Luminosité["datetime"]=Luminosité["time"].apply(stringdate_to_datetime)

Fenêtre= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Fenêtre.csv', sep= ',')
Fenêtre["datetime"]=Fenêtre["time"].apply(stringdate_to_datetime)

Humidité= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Humidité.csv', sep= ',')
Humidité["datetime"]=Humidité["time"].apply(stringdate_to_datetime)

Température= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/Température.csv', sep= ',')
Température["datetime"]=Température["time"].apply(stringdate_to_datetime)

CO2= pd.read_csv('/Users/Utilisateur/Documents/Ense3/Projet G11/Données/CO2.csv', sep= ',')
CO2["datetime"]=CO2["time"].apply(stringdate_to_datetime)


mergeData=[TV_power,Box_TV,Bruit,Lumière,Luminosité,Fenêtre,Humidité,Température,CO2]
result=pd.concat(mergeData, axis=1, join='inner')

print(result)

TV_power.set_index('datetime',inplace=True)
print("isnull",TV_power.isnull().any())
TV_power.ffill()
newTV_power=TV_power.resample('30T').sum()
print(newTV_power)


Box_TV.set_index('datetime',inplace=True)
print("isnull",Box_TV.isnull().any())
Box_TV.ffill()
newBox_TV=Box_TV.resample('30T').sum()
print(newBox_TV)


Bruit.set_index('datetime',inplace=True)
print("isnull",Bruit.isnull().any())
Bruit.ffill()
newBruit=Bruit.resample('30T').sum()
print(newBruit)


Lumière.set_index('datetime',inplace=True)
print("isnull",Lumière.isnull().any())
Lumière.ffill()
newLumière=Lumière.resample('30T').sum()
print(newLumière)


Luminosité.set_index('datetime',inplace=True)
print("isnull",Luminosité.isnull().any())
Luminosité.ffill()
newLuminosité=Luminosité.resample('30T').sum()
print(newLuminosité)


Fenêtre.set_index('datetime',inplace=True)
print("isnull",Fenêtre.isnull().any())
Fenêtre.ffill()
newFenêtre=Fenêtre.resample('30T').sum()
print(newFenêtre)


Humidité.set_index('datetime',inplace=True)
print("isnull",Humidité.isnull().any())
Humidité.ffill()
newHumidité=Humidité.resample('30T').sum()
print(newHumidité)


Température.set_index('datetime',inplace=True)
print("isnull",Température.isnull().any())
Température.ffill()
newTempérature=Température.resample('30T').sum()
print(newTempérature)


CO2.set_index('datetime',inplace=True)
print("isnull",CO2.isnull().any())
CO2.ffill()
newCO2=CO2.resample('30T').sum()
print(newCO2)

mergeData2=[newTV_power,newBox_TV,newBruit,newLumière,newLuminosité,newFenêtre,newHumidité,newTempérature,newCO2]
result2=pd.concat(mergeData2, axis=1, join='inner')

print(result2)

#result2.set_index('datetime',inplace=True)

hours=[]
result2_datetimes=pd.to_datetime(Luminosité.iloc[:,0], format='%Y-%m-%dT%H:%M:%S')

for dt in result2_datetimes:
    hours.append(dt.hour)

hours2=[]
for k in range (146):
    hours2.append(hours[k])

journée=[00.50 , 1,1.5,2,2.5,3,3.5,4,4.5,5,5.5,6,6.5,7,7.5,8,8.5,9,9.5,10,10.5,11,11.5,12,12.5,13,13.5,14,14.5,15,15.5,16,16.5,17,17.5,18,18.5,19,19.5,20,20.5,21,21.5,22,22.5,23,23.5,24]

hours3=[]
journée2=journée*10
for i in range(146):
    hours3.append(journée2[i+35])

result2['Heure']=hours3

# Occupancy

occupancy= []
for k in range (len(hours3)):
    if 17<=hours3[k]<=22:
        occupancy.append(1)
    elif 7<=hours3[k]<=9:
        occupancy.append(1)
    else:
        occupancy.append(0)


# Waste energy

window=result2['Fenêtre']
CO2_2=result2['CO2']
light=result2['Lumière']
TV=result2['TV_power']

for k in range (len(result2)):
    if window[k] ==1 and CO2_2[k]<=2000:
        print('Waste of energy at', hours3[k], "o'clock, because the window is open")
    # else:
    #     print('OK. Heure:',hours3[k])

for k in range (len(result2)):
    if (occupancy[k] ==0) and (light[k]==1 or TV[k]!=0):
        print('Waste of energy at', hours3[k], "o'clock, because of the light or the TV")

# Decision Tree

def decision_tree(x_train, x_test, y_train, y_test):
    clf = tree.DecisionTreeClassifier(max_depth=9)
    clf = clf.fit(x_train, y_train)
    y_test_pred = clf.predict(x_test)
    accuracy = clf.score(x_test, y_test)
    importance=clf.feature_importances_
    return importance,accuracy



x_train, x_test, y_train, y_test = train_test_split (
    result2[["TV_power","Box_TV", "Bruit", "Lumière","Luminosité","Fenêtre","Humidité","Température","CO2"]], 
    occupancy, test_size = .3, random_state = 0)

y_pred_occupancy= decision_tree(x_train, x_test,y_train, y_test)

depth=[1,2,3,4, 5, 6, 7, 8,9]


plt.plot(depth,y_pred_occupancy[0])
plt.show()